//+------------------------------------------------------------------+
//|                                                 superMATools.mqh |
//|                                     Copyright 2016 Elia Burstein |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016 Elia Burstein"
#property link      "https://www.mql5.com"
#property strict
const int MAPeriod=10;

double SuperPrice(ENUM_APPLIED_PRICE aPrice,int pos)
{
   return(iCustom(Symbol(),0,"SuperSmoother",MAPeriod,0,aPrice,0,pos));
}

const int BARS_USED = 3;

double usePrice(int position, ENUM_APPLIED_PRICE applied_price){
   switch(applied_price){
      case PRICE_CLOSE:
         return(Close[position]);
      case PRICE_OPEN:
         return(Open[position]);
      case PRICE_HIGH:
         return(High[position]);
      case PRICE_LOW:
         return(Low[position]);
      case PRICE_MEDIAN:
         return((High[position]+Low[position])/2);
      case PRICE_TYPICAL:
         return((High[position]+Low[position]+Close[position])/3);
      case PRICE_WEIGHTED:
         return((High[position]+Low[position]+Close[position]*2)/4);
      default:
         return(0);
   }
}

void attenuation(const double period, double &result[])
{
   double a  = MathExp(-1 * M_SQRT2 * M_PI / period);
   result[1] = 2 * a * MathCos(M_SQRT2 * M_PI / period);
   result[2] = -a * a;
   result[0] = 1 - result[1] - result[2];
}

double attenuation2(const double period,const double period2, double &result[])
{
   attenuation(period,result);
   double alpha = (MathCos(M_SQRT1_2*M_PI*360/180/period2)+MathSin(M_SQRT1_2*M_PI*360/180/period2)-1)/MathCos(M_SQRT1_2*M_PI*360/180/period2);
   return(alpha);
}

void superSmooth(const int position, const ENUM_APPLIED_PRICE applied_price, const double &attArray[], double &array[])
{
   int dir=(ArrayGetAsSeries(array)?1:-1);
   array[position]=attArray[0]*(usePrice(position,applied_price)+usePrice(position+dir,applied_price))/2 + attArray[1]*array[position+dir] + attArray[2]*array[position+2*dir];
}

void superSmooth2Phase1(int position, ENUM_APPLIED_PRICE applied_price, double alpha, const double &attArray[], double &array1[], double &array2[])
{
   int dir=(ArrayGetAsSeries(array1)?1:-1);
   array1[position]=(1-alpha/2)*(1-alpha/2)*(usePrice(position,applied_price)-2*usePrice(position+1,applied_price)+usePrice(position+2,applied_price))+2*(1-alpha)*array1[position+dir]-(1-alpha)*(1-alpha)*array1[position+2*dir];
   array2[position] = attArray[0] * (array1[position] + array1[position+dir]) / 2 + attArray[1] * array2[position+dir] + attArray[2] * array2[position+2*dir];
}

void superSmooth2Phase2(int position, const double &attArray[], const double &inArray[], double &outArray[])
{
   int dir=(ArrayGetAsSeries(inArray)?1:-1);
   outArray[position]=attArray[0]*(inArray[position]+inArray[position+dir])/2+attArray[1]*outArray[position+dir]+attArray[2]*outArray[position+2*dir];
}
